#include "strerr.h"
#include "subscribe.h"
#include "sgetopt.h"
#include "scan.h"
#include "errtxt.h"
#include "idx.h"

#define FATAL "ezmlm-unsub: fatal: "

void *psql = (void *) 0;

void die_usage()
{
  strerr_die1x(100,
   "ezmlm-unsub: usage: ezmlm-unsub [-h hash] [-mMrsvV] dir box@domain ...");
}

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;
  char *addr;
  int flagmysql = 1;		/* if there is mysql support, use it! */
  unsigned long forcehash = 0L;	/* do not specify the hash */
  int opt;

  (void) umask(022);

  while ((opt = getopt(argc,argv,"h:HrRsSmMvV")) != opteof)
    switch(opt) {
      case 'h': (void) scan_ulong(optarg,&forcehash); break;
      case 'H': forcehash = 0L; break;
      case 'm': flagmysql = 1; break;
      case 'M': flagmysql = 0; break;
      case 'r': forcehash = 98; break;
      case 'R': forcehash = 0; break;
      case 's': forcehash = 99; break;
      case 'S': forcehash = 0; break;
      case 'v':
      case 'V': strerr_die2x(0,
		"ezmlm-unsub version: ezmlm-0.53+",EZIDX_VERSION);
      default:
	die_usage();
    }

  dir = argv[optind++];
  if (!dir) die_usage();

  if (dir[0] != '/')
    strerr_die2x(100,FATAL,ERR_SLASH);

  while ((addr = argv[optind++]))
    (void) subscribe(dir,addr,0,"","-manual",flagmysql,
		(unsigned int) forcehash,FATAL);
  closesql();
  _exit(0);
}
