/*$Id: subreceipt.c,v 1.3 1999/01/08 03:56:38 lindberg Exp $*/
/*$Name: ezmlm-idx-0324 $*/

#include "subscribe.h"
#include "str.h"
#include "strerr.h"
#include "fmt.h"
#include "errtxt.h"
#include "stralloc.h"

char strnum[FMT_ULONG];
static stralloc line = {0};

int subreceipt(dir,msgnum,cookie,listaddr,done,info,fatal)
/* Logs receipts to mail log if non-sql. If list uses sql, bounces and   */
/* receipts are logged appropriately, if and only if the cookie tag      */
/* matches. The cookie mechanism isn't secure, but makes it quite hard to*/
/* falsify info. Returns 0 on success. For sql lists, failure is reported*/
/* as: */
/* -1 cookie didn't match/exist. */
/* -2 list isn't active. */
/* The list_mlog code for a bounce is -1, for receipt it is 2 */

char *dir;
unsigned long msgnum;
stralloc *cookie;
char *listaddr;
int done;
char *info;
char *fatal;
{
  char *ret = (char *) 0;
  char *table = (char *) 0;
  char *sublist = (char *) 0;

  if ((ret = opensql(dir,&table,&sublist))) {	/* open sql */
    if (*ret) strerr_die2x(111,fatal,ret);
				/* no SQL, log to mail log */
    strnum[fmt_ulong(strnum,msgnum)] = '\0';

    if (cookie->len) {		/* there was a tag */
      if (!stralloc_copy(&line,cookie)) strerr_die1x(111,ERR_NOMEM);
      if (!stralloc_0(&line)) strerr_die1x(111,ERR_NOMEM);
      if (done == 2)
        strerr_warn6(info,listaddr,": receipt ",strnum,": ",line.s,0);
      else
        strerr_warn6(info,listaddr,": bounce ",strnum,": ",line.s,0);
    } else {
      if (done == 2)
        strerr_warn5(info,listaddr,": receipt ",strnum,":",0);
      else
        strerr_warn5(info,listaddr,": bounce ",strnum,":",0);
    }
  return 0;
} else {
    if ((ret = checktag(dir,msgnum,cookie))) {		/* check tag */
      if (*ret) strerr_die2x(111,fatal,ret);
      return -1;					/* no/bad cookie */
    }
    if ((ret = getlistno(dir,msgnum,listaddr))) {	/* get list no */
      if (*ret) strerr_die2x(111,fatal,ret);
      return -2;					/* list not active */
    }
    if ((ret = logmsg(dir,msgnum,done)))		/* log it */
      if (*ret) strerr_die2x(111,fatal,ret);
  }
  return 0;
}

